Author: Bertrand Lanson <bertrand.lanson@protonmail.com>
Date: Fri, 27 Sep 2024 09:51:16 +0200
Description: Fix type passed to write function during backup restoration
 Cinder backup throws a TypeError when trying to restore to a new volume,
 because slicing a memoryview object does not return a byte string.
Bug: https://launchpad.net/bugs/2082587
Change-Id: Ibaf87af25dc33c59660be6e112ca78b993592385
Forwarded: https://review.opendev.org/c/openstack/cinder/+/930682
Last-Update: 2024-09-27

diff --git a/cinder/backup/chunkeddriver.py b/cinder/backup/chunkeddriver.py
index 490baf8..8f00332 100644
--- a/cinder/backup/chunkeddriver.py
+++ b/cinder/backup/chunkeddriver.py
@@ -78,7 +78,7 @@
         # The len(chunk) may be smaller than chunk_length. It's okay.
         if not volume_utils.is_all_zero(chunk):
             volume_file.seek(volume_offset + chunk_offset)
-            volume_file.write(chunk)
+            volume_file.write(chunk.tobytes())
 
 
 def _write_volume(volume_is_new, volume_file, volume_offset, content):
